<?php namespace App\Models\Admin;

use App\Models\Project\DatatableModel;

class Video_galleryModel extends AdminModel{
	private $table;
	
    public function __construct(){
		parent::__construct();
		$this->table = "video_gallery";
    } 
	
	public function get_datatable(){
		$dtObj = new DatatableModel($this->db);
		$dtObj->set_table($this->table." AS mt");
		// Set Datatable columns 
		$dtObj->set_column('mt.video_gallery_id', 'desc|sort|search', 'RecordID');
		$dtObj->set_column('ln.title', 'sort|search');
		$dtObj->set_column('mt.status', 'sort|search');
		$builder = $dtObj->get_builder();
		$builder->where('mt.is_deleted','No');
		$builder->join($this->table."_ln AS ln","mt.video_gallery_id=ln.video_gallery_id AND ln.language_code='".$this->project->default_lang_code."'",'inner');
		return $dtObj->get_data($builder);		
	}
		
	public function get($language_list,$id){
		$builder = $this->db->table($this->table." AS mt");
		$columns = ["mt.*"];
		$ln_columns = ['video_gallery_ln_id',
			'title',
			'language_code'];
		if($language_list){
			foreach($language_list as $language){
				foreach($ln_columns as $col_name){
					array_push($columns,$language['code'].".".$col_name." AS ".$col_name."_".$language['code']);
				}
				$builder->join($this->table."_ln AS ".$language['code'],"mt.video_gallery_id=".$language['code'].".video_gallery_id AND ".$language['code'].".language_code='".$language['code']."'",'left');
			}
		}
		$builder->select(implode(", ",$columns));
		$builder->where('mt.video_gallery_id',$id);
		$query = $builder->get();
		//echo $builder->getCompiledSelect();
		return $query->getRowArray();
	}
	
	public function insert($data){
		$this->add_insert_log($data);
		$builder = $this->db->table($this->table);
		$builder->insert($data);
		return $this->db->insertID();
	}
	
	public function update($data,$video_gallery_id){
		$this->add_update_log($data);
		$builder = $this->db->table($this->table);
		$builder->where('video_gallery_id',$video_gallery_id);
		$builder->update($data);
	}
	
	public function delete($video_gallery_id){
		$data['is_deleted'] = "Yes";
		$this->add_update_log($data);
		$builder = $this->db->table($this->table);
		$builder->where('video_gallery_id',$video_gallery_id)
				->update($data);
	}
	
	public function update_language_data($data,$video_gallery_ln_id){
		$builder = $this->db->table($this->table.'_ln');
		$builder->where('video_gallery_ln_id',$video_gallery_ln_id)
		->update($data);
	}
	
	public function insert_language_data($data){
		$builder = $this->db->table($this->table.'_ln');
		$builder->insert($data);
	}
	
	public function is_unique_photo_title($title,$video_gallery_id){
		$builder = $this->db->table($this->table);
		$builder->where('is_deleted','No')
				->where('title',$title);
		if($video_gallery_id){
			$builder->where('video_gallery_id!=',$video_gallery_id);
		}
		$query = $builder->get();
		if($query->getRowArray()){
			$response = "FALSE|The Title already exist!";
		}else{
			$response = "TRUE|";
		}
		return $response;
	}
}